#!/usr/bin/env python3

from html import escape

from models import Subscriber
from telegram import Bot

from config import BOT_TOKEN


bot = Bot(BOT_TOKEN)

subs = Subscriber.select()

messages = []
for sub in subs:
    chat = bot.send_message(sub.user_id, '.').chat
    chat_name = escape(f'{chat.first_name or ""} {chat.last_name or ""} {chat.title or ""}'.rstrip())
    messages.append(f'<pre>#{sub.id:>4} {sub.user_id:>20} </pre><a href="tg://user?id={sub.user_id}">{chat_name}</a>')

bot.send_message(98934915, '\n'.join(messages), parse_mode='html')
